from es import AddonInfo, ServerVar, setindexprop, getentityindex, getuserid
from playerlib import getPlayer, getUseridList
from repeat import create as rcreate
from cfglib import AddonCFG


info = AddonInfo()
info.name = 'Fixed Ping'
info.version = 1.0
info.basename = 'fixed_ping'
info.url = 'http://addons.eventscripts.com/addons/view/fixed_ping'
info.author = 'Dead Man Walker'

def load():
   global ping_loop
   createCfg()
   if cfg_steamid_fixed_ping:
      ping_loop = rcreate('ping_loop', loopConfig)
      ping_loop.start(LOOP_INTERVAL, 0)   

def unload():
   if cfg_steamid_fixed_ping:
      ping_loop.delete()

def es_map_start(event_var):
   createCfg()

def loopConfig():
   if "ALL" in cfg_steamid_fixed_ping:
      for userid in getUseridList('#all'):
         setPing(userid, cfg_steamid_fixed_ping['ALL'])
      return
   if "BOT" in cfg_steamid_fixed_ping:
      for userid in getUseridList('#bot'):
         setPing(userid, cfg_steamid_fixed_ping['BOT'])
   for steamid in cfg_steamid_fixed_ping:
      userid = getuserid(steamid)
      if steamid.startswith('STEAM') and userid:
         setPing(userid, cfg_steamid_fixed_ping[steamid])
      
   

def setPing(userid, ping):
   setindexprop(getentityindex('cs_player_manager'), "CPlayerResource.m_iPing.%03d" %getPlayer(userid).get('index'), ping)

def createCfg():
   global LOOP_INTERVAL, cfg_steamid_fixed_ping
   cfg = AddonCFG(ServerVar('eventscripts_gamedir') + "/cfg/fix_ping.cfg")
   cfg.text('************************************************************')
   cfg.text('*** Fix Ping Config')
   cfg.text('************************************************************')
   cfg.text(' ')
   LOOP_INTERVAL = float(cfg.cvar("loop_interval", 0.2, "The interval at which the pings are reset"))
   cfg.text('Set the ping for individual SteamIDs')
   cfg.text('For bots use the word "BOT", to affect every one user the word "ALL"')
   cfg.text('User a semicolon (;) to seperate')
   cfg.text('Syntax:')
   cfg.text('<SteamId>=<ping> or BOT=<ping> or ALL=<ping>')
   cfg.text('Example of usage=')
   cfg.text('STEAM_0:0:101010101=100;STEAM_0:0:0101010101=10;BOT=999')
   steamid_fixed_ping_string = str(cfg.cvar("steamid_fixed_ping_string", "", "Leave blank for no effect"))
   cfg.text('Side note: ping cannot be longer than 3 numbers and must consist of whole numbers!')
   cfg.write()
   cfg.execute()

   steamid_fixed_ping_string = steamid_fixed_ping_string.strip()
   if not steamid_fixed_ping_string:
      cfg_steamid_fixed_ping = 0
   else:
      steamid_ping_list = steamid_fixed_ping_string.split(';')
      cfg_steamid_fixed_ping = {}
      for steamid_ping in steamid_ping_list:
         if not steamid_ping:
            continue
         steamid_ping_seperate = steamid_ping.split('=')
         if len(steamid_ping_seperate) != 2:
            raise IndexError, "Syntax is <Steamid>=<ping>"
            continue
         if 'STEAM' not in steamid_ping_seperate[0] and steamid_ping_seperate[0].upper() not in ('BOT', 'ALL'):
            raise ValueError, "First part must be a SteamID, the word 'BOT' or 'ALL'"
            continue
         try:
            steamid_ping_seperate[1] = int(steamid_ping_seperate[1])
         except ValueError:
            raise "Second part must be a whole number"
            continue
         cfg_steamid_fixed_ping[steamid_ping_seperate[0].upper()] = steamid_ping_seperate[1]
   